--[[
	Author: Darcey.Lloyd@gmail.com

	USEFUL TO GET FRAME NAME IN GAME CHAT:
	/run print(GetMouseFocus():GetName() .. "\n")
--]]



-- Addon Global Variables (shared between files but not addons). addon var name can be renamed
local AddOnName, addon = ...;
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #








-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
addon.getCoords = function(decimalPrecision)
	if (not decimalPrecision) then
		decimalPrecision = 1;
	end
    local mapID = C_Map.GetBestMapForUnit("player");
    local coords = "";
    if (mapID) then
        local position = C_Map.GetPlayerMapPosition(mapID,"player") -- Memory leak on this (nothing I can do about it bliz!)
        if (position) then
            x = position.x * 100;
            y = position.y * 100;
			-- x = math.floor(x*100)/100; -- string.format("%.2f",position.x);
			local precision = "%.".. decimalPrecision .."f";
			x = string.format(precision, x);
			y = string.format(precision, y);
			coords = {}
			coords.x = x
			coords.y = y
            return coords;
        else
            return nil;
		end
	else
		return nil;
    end

end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #






-- addon.createEditBox
-- https://wowwiki.fandom.com/wiki/UIOBJECT_EditBox
addon.createEditBox = function(x,y,w,align,maxLetters)
	local r1 = math.random(0, 999999);
	local editBoxName = "DGPSEditBox" .. r1;
	local editBox = CreateFrame("EditBox",editBoxName,addon.inputFrame.frame,"InputBoxTemplate");
	editBox:SetWidth(w);
	editBox:SetHeight(14);
	-- editBox:SetScale(0.6);
	editBox:SetPoint("TOPLEFT", x,y);
	editBox:SetMaxLetters(maxLetters);
	editBox:SetMultiLine(false);
	editBox:SetAutoFocus(false);
	editBox:SetFont(DTools.defaultFont,11,"NONE");
	-- editBox:SetText("AFTC");
	editBox:ClearFocus();
	-- editBox:SetNumeric();
	editBox:SetText("- 0 -");
	editBox:SetJustifyH(align);
	-- editBox:SetText(formattedDefaultValue);
	editBox:HighlightText(0,0);
	editBox:SetCursorPosition(0);
	editBox:ClearFocus();

	return editBox;
end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #





-- addon.getUserCoordinates
addon.getUserCoordinates = function()
	local selectedIndex = DGPS_DB["SelectedCheckboxIndex"] ;
	local tx = tonumber(addon.inputFrame.inputX[selectedIndex]:GetText());
	local ty = tonumber(addon.inputFrame.inputY[selectedIndex]:GetText());
	if (tx == nil) then tx = 0; end
	if (ty == nil) then ty = 0; end

	-- print("addon.getUserCoordinates: " .. tx .. " - " .. ty);
	-- local x = tonumber(DGPS_DB["inputX"][selectedIndex]:GetText())

	-- print(x);

	local vo = {}
	vo.x = tx;
	vo.y = ty;
	return vo;

end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #


addon.editBoxClearFocus = function(eb)
	eb:HighlightText(0,0);
	eb:SetCursorPosition(0);
	eb:ClearFocus();
end


addon.clearAllEditBoxFocus = function()
	for i = 1, 4, 1 do
		local eb1 = addon.inputFrame.inputName[i];
		local eb2 = addon.inputFrame.inputX[i];
		local eb3 = addon.inputFrame.inputY[i];
		-- local cb = addon.inputFrame.checkBox[i];
		addon.editBoxClearFocus(eb1);
		addon.editBoxClearFocus(eb2);
		addon.editBoxClearFocus(eb3);
	end
end



-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
addon.checkboxClickHandler = function(index,checked)
	for i = 1, 4, 1 do
		local cb = addon.inputFrame.checkBox[i];
		if (i == index) then
			cb:SetChecked(true);
			DGPS_DB["SelectedCheckboxIndex"] = i;
		else
			cb:SetChecked(false);
		end
	end
end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #








-- addon.GetZoneDetails
addon.getZoneDetails = function()
	-- Should only be run on event change from eventFrame
	addon.location.zone = GetZoneText()
	addon.location.subZone = GetSubZoneText()

	if (addon.location.zone ~= "") and (addon.location.subZone ~= "") then
		addon.location.label = addon.location.zone .. " - " .. addon.location.subZone;
	elseif (addon.location.zone == "") and (addon.location.subZone ~= "") then
		addon.location.label = addon.location.subZone;
	elseif (addon.location.zone ~= "") and (addon.location.subZone == "") then
		addon.location.label = addon.location.zone;
	else
		addon.location.label = "";
	end

	if (addon.debug) then
		DTools.log("addon.location.subZone = " .. addon.location.subZone , "00CC00")
		DTools.log("addon.location.zone = " .. addon.location.zone , "00CC00")
		DTools.log("addon.location.label = " .. addon.location.label , "00CC00")
	end
end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #




addon.setInitialState = function()
	addon.checkboxClickHandler(DGPS_DB["SelectedCheckboxIndex"],true); -- set initial activated checkbox
	addon.setInputValues();
	if (DGPS_DB["visible"]) then
		addon.show();
	else
		addon.hide();
	end
end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #


addon.show = function()
	addon.inputFrame.frame:Show();
	addon.arrowFrame.frame:Show();
end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #

addon.hide = function()
	addon.inputFrame.frame:Hide();
	addon.arrowFrame.frame:Hide();
end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
