--[[
	Author: Darcey.Lloyd@gmail.com

	USEFUL TO GET FRAME NAME IN GAME CHAT:
	/run print(GetMouseFocus():GetName() .. "\n")
--]]



-- Addon Global Variables (shared between files but not addons). addon var name can be renamed
local AddOnName, addon = ...;
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #



-- Var ini
addon.name = "DGPS"
addon.version = "2.0.1"
addon.debug = false;

addon.initComplete = false;
addon.frames = {}
addon.frames.eventFrame = nil;


addon.location = {};
addon.location.zone = nil;
addon.location.subZone = nil;

addon.coords = nil;

addon.distToTarget = nil;


addon.inputFrame = {}
addon.inputFrame.frame = nil;
addon.inputFrame.frameW = 307;
addon.inputFrame.frameH = 131;

addon.inputFrame.labelTitle = nil;
addon.inputFrame.coordinatesFrame = nil;

addon.inputFrame.labelLocation = nil;
addon.inputFrame.labelCoords = nil;
addon.inputFrame.labelDistance = nil;

addon.inputFrame.inputName = {}; -- edit boxes
addon.inputFrame.inputX = {}; -- edit boxes
addon.inputFrame.inputY = {}; -- edit boxes
addon.inputFrame.checkBox = {}; -- checkbox objects
addon.inputFrame.checkBoxClickFunctions = {};


addon.arrowFrame = {}
addon.arrowFrame.frame = nil;
addon.arrowFrame.texture = nil;





addon.menu = {}
addon.menu.api = nil
addon.menu.mainPage = nil
addon.menu.titleTextSize = 18
addon.menu.textSize = 12


addon.time = {}
addon.time.now = 99999999;
addon.time.prev = 0;
addon.time.updateFreq = 1000; -- Milliseconds 1000 = 1 sec
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #






-- addon.initPersistentVars
addon.initPersistentVars = function()
	if (not DGPS_DB) then
		DGPS_DB = {}
	end

	if (DGPS_DB["InputFrame"] == nil) then
		DGPS_DB["InputFrame"] = {}
		DGPS_DB["InputFrame"].x = 0
		DGPS_DB["InputFrame"].y = 0
	end

	if (DGPS_DB["ArrowFrame"] == nil) then
		DGPS_DB["ArrowFrame"] = {}
		DGPS_DB["ArrowFrame"].x = 0
		DGPS_DB["ArrowFrame"].y = 0
	end

	DGPS_DB["UpdateFrequency"] = 0.02;
	if (DGPS_DB["UpdateFrequency"] == nil) then
		DGPS_DB["UpdateFrequency"] = 1;
	end

	-- Data storage
	if (DGPS_DB["inputName"] == nil) then
		DGPS_DB["inputName"] = {};
	end

	if (DGPS_DB["inputX"] == nil) then
		DGPS_DB["inputX"] = {};
	end

	if (DGPS_DB["inputY"] == nil) then
		DGPS_DB["inputY"] = {};
	end

	if (DGPS_DB["checkBox"] == nil) then
		DGPS_DB["checkBox"] = {};
	end


	if (DGPS_DB["SelectedCheckboxIndex"] == nil) then
		DGPS_DB["SelectedCheckboxIndex"] = 1;
	end



	if (DGPS_DB["visible"] == nil) then
		DGPS_DB["visible"] = true;
	end



end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #





-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
addon.saveInputValues = function()
	-- DGPSTools.log("addon.saveInputValues()");
	for i = 1, 4, 1 do
		local inputName = addon.inputFrame.inputName[i];
		local x = addon.inputFrame.inputX[i];
		local y = addon.inputFrame.inputY[i];

		DGPS_DB["inputName"][i] = inputName:GetText();
		DGPS_DB["inputX"][i] = x:GetText();
		DGPS_DB["inputY"][i] = y:GetText();
	end
end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #





-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
addon.setInputValues = function()
	for i = 1, 4, 1 do
		local eb1 = addon.inputFrame.inputName[i];
		local eb2 = addon.inputFrame.inputX[i];
		local eb3 = addon.inputFrame.inputY[i];

		if (eb1 ~= nil) then
			eb1:SetText( DGPS_DB["inputName"][i] );
		end

		if (eb2 ~= nil) then
			eb2:SetText( DGPS_DB["inputX"][i] );
		end

		if (eb3 ~= nil) then
			eb3:SetText( DGPS_DB["inputY"][i] );
		end
	end
end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #