--[[
	Author: Darcey.Lloyd@gmail.com

	USEFUL TO GET FRAME NAME IN GAME CHAT:
	/run print(GetMouseFocus():GetName() .. "\n")
--]]



-- Addon Global Variables (shared between files but not addons). addon var name can be renamed
local AddOnName, addon = ...;
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #





function getAngle(cx, cy, ex, ey)
	local dy = ey - cy;
	local dx = ex - cx;
	local theta = atan2(dy, dx); -- range (-PI, PI]
	-- theta *= 180 / Math.PI; -- rads to degs, range (-180, 180]
	--if (theta < 0) theta = 360 + theta; // range [0, 360)
	return theta;
end


local region = nil;
local rDeg = 0;

-- onUpdateHandler
addon.onUpdateHandler = function()
	-- Only run this when init has been completed
	if (addon.initComplete == false) then
		return
	end

	-- Check if it's time to update
	addon.time.now = GetTime();

	local timeSinceLastUpdate = addon.time.now - addon.time.prev;

    if (timeSinceLastUpdate >= DGPS_DB["UpdateFrequency"]) then
		-- DTools.log("addon.onUpdateHandler(): UPDATE:" .. addon.time.now,"00CC00")


		addon.coords = DGPSTools.getCoords(2);
		local targetCoords = addon.getUserCoordinates()
		local playerAngle = GetPlayerFacing();
		local angle = nil;
		local RegionAngle = nil;
		local CompleteAngle = nil;
		local rad = nil;

		if (addon.coords ~= nil and targetCoords ~= nil and playerAngle ~= nil) then
			local cx = tonumber(addon.coords.x)
			local cy = tonumber(addon.coords.y)
			local tx = tonumber(targetCoords.x)
			local ty = tonumber(targetCoords.y)
			-- angle = getAngle(addon.coords.x,addon.coords.y,tx,ty)
			-- angle = angle + 90;
			-- print(angle);
			-- addon.arrowFrame.texture:SetRotation(DTools.degToRad(angle));

			local distX = 0;
			local distY = 0;

			if (cx > tx) then
				if (cy < ty) then
					region = "Q1";
					distX = cx - tx;
					distY = ty - cy;
				else
					region = "Q2";
					distX = cx - tx;
					distY = cy - ty;
				end
			else
				if (cy > ty) then
					region = "Q3";
					distX = tx - cx;
					distY = cy - ty;
				else
					region = "Q4";
					distX = tx - cx;
					distY = ty - cy;
				end
			end



			if (region == "Q1") then
				RegionAngle = atan((distX/distY));
				CompleteAngle = RegionAngle;
				rad = CompleteAngle * (math.pi/180);
			end

			if (region == "Q2") then
				RegionAngle = atan((distY/distX));
				CompleteAngle = RegionAngle + 90;
				rad = CompleteAngle * (math.pi/180);
			end

			if (region == "Q3") then
				RegionAngle = atan((distX/distY));
				CompleteAngle = RegionAngle + 180;
				rad = CompleteAngle * (math.pi/180);
			end

			if (region == "Q4") then
				RegionAngle = atan((distY/distX));
				CompleteAngle = RegionAngle + 270;
				rad = CompleteAngle * (math.pi/180);
			end


			rad = rad + DTools.degToRad(180);
			rad = -(rad + playerAngle);
			-- print(rad);

			addon.distToTarget = sqrt( math.pow((cx-tx), 2) + math.pow((cy-ty), 2) );
			-- print(addon.distToTarget);

			addon.arrowFrame.texture:SetRotation(rad);

		else
			addon.arrowFrame.texture:SetRotation(0);
		end









		-- tex:SetRotation(radians[, cx, cy])
		-- addon.arrowFrame.texture:SetRotation(DTools.degToRad(rDeg));
		-- addon.frames.arrowFrame
		-- rDeg = rDeg+1;
		-- DTools.log(rDeg);


		-- DTools.log(addon.coords)
		if (addon.coords ~= nil) then

			-- local part1 = GetZoneText() .. "  - " .. GetSubZoneText() .. "  ";
			local part1 = GetZoneText() .. "  ";
			local part2 = "[" .. addon.coords.x .. " - " .. addon.coords.y .. "]  ";
			addon.inputFrame.labelLocation:SetText(part1 .. part2);


			-- addon.inputFrame.labelCoords:SetText(part2);


			local part3 = "";
			if (addon.distToTarget ~= nil) then
				addon.distToTarget = addon.distToTarget * 100;
				part3 = "Distance: " .. math.floor(addon.distToTarget)/10;
			else

			end
			addon.inputFrame.labelDistance:SetText(part3);

			-- addon.inputFrame.labelCoords:SetText(part1 .. part2 .. part3)
		else
			addon.inputFrame.labelLocation:SetText("");
			addon.inputFrame.labelLocation:SetText("");
			addon.inputFrame.labelDistance:SetText("");
		end


        addon.time.prev = addon.time.now;
    end
end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #

